//Marinel Serban - aprilie 2015 - 100p
#include <fstream>

using namespace std;

ifstream fin("teren.in");
ofstream fout("teren.out");

#define DIMMAX 200

short int Teren[DIMMAX][DIMMAX], N, M, T, R, C,P;
short int X, Y, Z, U;
short int rasp2, rasp3, t, i, j;
short int TerenLiber[DIMMAX][DIMMAX];

int main()
{
   fin >> P>> N >> M >> T >> R >> C;           //citesc datele
   for (t = 1; t <= T; ++t)
   {
      fin >> X >> Y >> Z >> U;             //citesc si
      for (i = X; i <= Z; ++i)             //prelucrez inscrisul t
         for (j = Y; j <= U; ++j)
         {
            Teren[i][j]++;
            if (Teren[i][j]>rasp2)         //determin si zona maxima
               rasp2 = Teren[i][j];        //pe parcurs
         }
   }
   if(P==1)fout << Teren[R][C] << '\n';            //afisez raspuns la a)
   else
    if(P==2)fout << rasp2 << '\n';                  //afisez raspuns la b)
   else {
   for (i = 1; i <= N; ++i)
      for (j = 1; j <= M; ++j)
         if (Teren[i][j])
            Teren[i][j] = -1;              //marchez zone ocupate
//ideea: construiesc o matrice care retine coltul din dreapta jos
//a patratului liber posibil maxim in acest loc
//pot utiliza doar 2 linii, dar pentru cei mici si dimensiunile
//date, merge si cu construirea intregii matrici
   for (j = 1; j <= M; ++j)
      if (!Teren[1][j])
         TerenLiber[1][j] = 1;             //in linia 1 nu poate fi decat patrate de latura 1
   for (i = 2; i <= N; ++i)                //in celelalte linii se extind patratele
   {
      if (!Teren[i][1])                    //in coloana 1 doar zona de 1x1
         TerenLiber[i][1] = 1;
      for (j = 2; j <= M; ++j)             //pentru celelalte coloane
      {
         if (!Teren[i][j])                 //eventual se extinde
            TerenLiber[i][j] = 1 + min(min(TerenLiber[i][j-1], TerenLiber[i-1][j]), TerenLiber[i-1][j-1]);
         if (TerenLiber[i][j]>rasp3)       //daca s-a gasit un patrat mai mare
            rasp3 = TerenLiber[i][j];      //se retine
      }
   }
   fout << rasp3 * rasp3 << '\n';}
   return 0;
}
