//Emanuela Cerchez 60 puncte 
#include <cstdio>
#include <cassert>
#include <cstring>
#include <algorithm>
#define NMAX 100001
#define SMAX 86400

using namespace std;
FILE * fin=fopen("tv.in","r");
FILE * fout=fopen("tv.out","w");


int N, c;
struct punct {int t, tip;};
punct p[NMAX*2];

bool compar (punct p1, punct p2)
{
	return p1.t<p2.t || p1.t==p2.t && p1.tip<p2.tip;
}
int cerinta1();
int cerinta2();

int main()
{int i, d, hh, mm, ss, j, t;
 fscanf(fin,"%d%d",&c,&N);
 assert(c==1 || c==2);
 assert(N<NMAX);

 for (i=0; i<N; i++)
      {
      	fscanf(fin,"%d %d:%d:%d", &d, &hh, &mm, &ss);
      	t=hh*3600+mm*60+ss;
      	//assert(t+d<=SMAX);
      	//assert(hh>=0 && hh<24);
      	//assert(mm>=0 && mm<60);
      	//assert(ss>=0 && ss<60);
      	p[2*i].t=t; p[2*i].tip=0;
      	if (t+d>=SMAX) p[2*i+1].t=SMAX-1;
      	   else p[2*i+1].t=t+d-1;
      	p[2*i+1].tip=1;
      }
 sort(p,p+2*N, compar);
 if (c==1)
	t=cerinta1();
    else
	t=cerinta2();
 hh=t/3600; t%=3600; mm=t/60; ss=t%60;
 fprintf(fout,"%02d:%02d:%02d\n", hh,mm,ss);
 fclose(fout);
 return 0;
}

int cerinta1()
{int i, last, total, nr=1;
 total=p[0].t; nr=1;
 for (i=1; i<2*N; i++)
	  if (p[i].tip==0)
          {nr++;
           if (nr==1) total+=p[i].t-last;
		  }
          else
		  {
		   	nr--;
		   	if (nr==0) last=p[i].t+1;
		   }
  total+=SMAX-p[2*N-1].t-1;
  return total;
 }


int cerinta2()
{int i, maxim=0, timp, nr=0;
 for (i=0; i<2*N; i++)
	  if (p[i].tip==0)
          {nr++;
           if (nr>maxim) {maxim=nr; timp=p[i].t;}
          }
           else
		   nr--;
  return timp;
 }

