#include <iostream>
#include <fstream>

using namespace std;

ifstream f ("lightbot.in");
ofstream g ("lightbot.out");

const int NMAX = 200000 + 1;

int n;
int jucatori_nivel[NMAX];

void numara_jucatori() {
    int x, y, nr = 1;
    bool nivel_sarit = false;
    f >> x;

    while(f >> y) {
        if (y == x + 2) {
            if (nivel_sarit == true) {
                nr++;
                nivel_sarit = false;
            }
            else nivel_sarit = true;
        }
        else if (y != x + 1) {
            nr++;
            nivel_sarit = false;
        }
        x = y;
    }
    g << nr << '\n';
}

void nivel_accesat() {
    int maxim = -1, nivel = -1;
    int x;
    while(f >> x) {
        jucatori_nivel[x]++;
        if (jucatori_nivel[x] > maxim) {
            maxim = jucatori_nivel[x];
            nivel = x;
        }
        else if (jucatori_nivel[x] == maxim) {
            nivel = max(nivel, x);
        }
    }
    g << nivel << '\n';
}

void nivele_sarite() {
    int x, y, z, nr = 1;
    bool nivel_sarit = false;
    f >> x;

    while(f >> y) {
        if (y == x + 2) {
            if (nivel_sarit == true) {
                nr++;
                nivel_sarit = false;
            }
            else {
                nivel_sarit = true;
                g << y - 1 << ' ';
            }
        }
        else if (y != x + 1) {
            nivel_sarit = false;
        }
        x = y;
    }
}

int main() {
    int tip;
    f >> tip >> n;
    if (tip == 1) numara_jucatori();
    else if (tip == 2) nivel_accesat();
    else nivele_sarite();
    return 0;
}
