//Marinel Serban - aprilie 2015
#include <stdio.h>

FILE *fin, *fout;

#define DIMMAX 200

int Teren[DIMMAX][DIMMAX], N, M, T, R, C;
int X, Y, Z, U;
int rasp2, rasp3, t, i, j, cerinta, min;
int TerenLiber[DIMMAX][DIMMAX];

int main()
{
   fin = fopen("teren.in", "r");
   fout = fopen("teren.out", "w");
   fscanf(fin, "%d", &cerinta);
   fscanf(fin, "%d%d%d%d%d", &N, &M, &T, &R, &C);           //citesc datele
   for (t = 1; t <= T; ++t)
   {
      fscanf(fin, "%d%d%d%d", &X, &Y, &Z, &U);             //citesc si
      for (i = X; i <= Z; ++i)             //prelucrez inscrisul t
         for (j = Y; j <= U; ++j)
         {
            Teren[i][j]++;
            if (Teren[i][j]>rasp2)         //determin si zona maxima
               rasp2 = Teren[i][j];        //pe parcurs
         }
   }
   if (cerinta == 1)
      fprintf(fout, "%d\n", Teren[R][C]);            //afisez raspuns la a)
   if (cerinta == 2)
      fprintf(fout, "%d\n", rasp2);                  //afisez raspuns la b)
   for (i = 1; i <= N; ++i)
      for (j = 1; j <= M; ++j)
         if (Teren[i][j])
            Teren[i][j] = -1;              //marchez zone ocupate
//ideea: construiesc o matrice care retine coltul din dreapta jos
//a patratului liber posibil maxim in acest loc
//pot utiliza doar 2 linii, dar pentru cei mici si dimensiunile
//date, merge si cu construirea intregii matrici
   for (j = 1; j <= M; ++j)
      if (!Teren[1][j])
         TerenLiber[1][j] = 1;             //in linia 1 nu poate fi decat patrate de latura 1
   for (i = 2; i <= N; ++i)                //in celelalte linii se extind patratele
   {
      if (!Teren[i][1])                    //in coloana 1 doar zona de 1x1
         TerenLiber[i][1] = 1;
      for (j = 2; j <= M; ++j)             //pentru celelalte coloane
      {
         if (!Teren[i][j])                 //eventual se extinde
            {
               min = TerenLiber[i][j-1];
               if (TerenLiber[i-1][j] < min) min = TerenLiber[i-1][j];
               if (TerenLiber[i-1][j-1] < min) min = TerenLiber[i-1][j-1];
               TerenLiber[i][j] = 1 + min;
            }
         if (TerenLiber[i][j]>rasp3)       //daca s-a gasit un patrat mai mare
            rasp3 = TerenLiber[i][j];      //se retine
      }
   }
   if (cerinta == 3)
      fprintf(fout, "%d\n", rasp3 * rasp3);
   return 0;
}
