#include <cstdio>
#include <cassert>
#define MAXN 151

using namespace std;

int A[MAXN][MAXN];
int left, right, mid, sol, nr;
int N, M, K;

int main()
{
	freopen("ssk.in", "r", stdin);
	freopen("ssk.out", "w", stdout);

	scanf("%d %d %d", &N, &M, &K);
    assert(N>0 && N<=150 && M>0 && M<=150);
	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= M; ++j) {
			scanf("%d", &A[i][j]);
			assert(A[i][j]>=0 && A[i][j]<=1000);
			A[i][j] = A[i][j] + A[i][j - 1] + A[i - 1][j] - A[i - 1][j - 1];
		}

	left = 0; right = A[N][M]; sol = 0;
	while (left <= right) {
		mid = (left + right) / 2;
		nr = 0;
		int x1, y1, x2, y2;
		for (x1 = 1; x1 <= N; ++x1)
			for (x2 = x1; x2 <= N; ++x2)
				for (y1 = 1, y2 = 1; y2 <= M; ++y2) {
					while (y1 <= y2 && A[x2][y2] - A[x2][y1 - 1] - A[x1 - 1][y2] + A[x1 - 1][y1 - 1] > mid)
						++y1;
					nr += y2 - y1 + 1;
				}
		if (nr >= K) {
			sol = mid;
			right = mid - 1;
		}
		else
			left = mid + 1;
	}

	printf("%d\n", sol);

	return 0;
}
