#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXN 151
#define MAXV 1000

int A[MAXN][MAXN];
int N, M, K, nr;
vector<int> G;

int main()
{
	freopen("ssk.in", "r", stdin);
	freopen("ssk.out", "w", stdout);

	scanf("%d %d %d", &N, &M, &K);

	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= M; ++j) {
			scanf("%d", &A[i][j]);
			A[i][j] = A[i][j] + A[i][j - 1] + A[i - 1][j] - A[i - 1][j - 1];
		}

	G.resize((N * (N + 1) / 2) * (M * (M + 1) / 2));
	for (int x1 = 1; x1 <= N; ++x1)
		for (int x2 = x1; x2 <= N; ++x2)
			for (int y1 = 1; y1 <= M; ++y1)
				for (int y2 = y1; y2 <= M; ++y2)
					G[nr++] = A[x2][y2] - A[x2][y1 - 1] - A[x1 - 1][y2] + A[x1 - 1][y1 - 1];

	sort(G.begin(), G.end());
	printf("%d\n", G[K - 1]);

	return 0;
}
